Attribute VB_Name = "Sample"
'===================================================================
' aISA59s.bas
'-------------------------------------------------------------------
' aISA-M59
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' Date Dec.1998
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================
Option Explicit
Private Const szAisa59 = "aISA-M59"
Private Declare Function GetLastError Lib "kernel32" () As Long

'===================================================================
' Jn
'===================================================================
Sub Main()
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As LoadResConstants
    Dim wLogSlot As Integer
    Dim wAxis As Integer
    Dim ri As AISA59RESOURCE
    Dim b As Byte
    Dim dwCount As Long

    '---------------------------------------------------------------
    ' Aisa59.Dll J
    '---------------------------------------------------------------
    If False = Aisa59wDllOpen() Then
        ErrorMessage (AISA59_SLOT_AUTO)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' o[W\
    '---------------------------------------------------------------
    If False = Aisa59wGetVersion(dwDllVer, dwDrvVer) Then
        ErrorMessage (AISA59_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' foCX̎gp錾
    '---------------------------------------------------------------
    wLogSlot = AISA59_SLOT_AUTO '󂫃foCXw
    If False = Aisa59wCreate(wLogSlot) Then
        ErrorMessage (AISA59_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "aISA-M59 Created" + Chr(10) + Chr(10) + _
             "LogSlot: " + Str(wLogSlot)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' \[X\
    '---------------------------------------------------------------
    If False = Aisa59wGetResource(wLogSlot, ri) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "Board Name: " + szAisa59 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)
    '---------------------------------------------------------------
    ' Pw
    '---------------------------------------------------------------
    wAxis = AISA59_AXIS_1
    '---------------------------------------------------------------
    ' 䎲
    '---------------------------------------------------------------
    If False = Aisa59_InitAxis(wLogSlot, wAxis) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aISA-M59" + Chr(10) + _
             "䎲܂"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' { 1000pXo
    '---------------------------------------------------------------
    If False = Aisa59wDataFullWrite( _
        wLogSlot, wAxis, AISA59_PLUS_PRESET_PULSE_DRIVE, 1000) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aISA-M59" + Chr(10) + _
             "{ 1000pXo͂Ă܂"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' hCuXe[^X擾
    '---------------------------------------------------------------
    If False = Aisa59wGetDriveStatus(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' rW[tOĂihCuȂj~
    '---------------------------------------------------------------
    If b And &H1 Then
        If False = Aisa59wCommandWrite( _
            wLogSlot, wAxis, AISA59_SLOW_DOWN_STOP) Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If
        strbuf = "aISA-M59" + Chr(10) + _
                 "~܂"
        ResultMessage (strbuf)
    End If
    '---------------------------------------------------------------
    ' GhXe[^X擾
    '---------------------------------------------------------------
    If False = Aisa59wGetEndStatus(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aISA-M59" + Chr(10) + _
             "GhXe[^X " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' JE^[\
    '---------------------------------------------------------------
    If False = Aisa59wDataFullRead( _
        wLogSlot, wAxis, AISA59_INTERNAL_COUNTER_READ, dwCount) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' g
    '---------------------------------------------------------------
    If dwCount And &H8000000 Then dwCount = dwCount Or &HF0000000

    strbuf = "aISA-M59" + Chr(10) + _
             "JE^ " + CStr(dwCount)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' JjJVOi\
    '---------------------------------------------------------------
    If False = Aisa59wGetMechanicalSignal(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aISA-M59" + Chr(10) + _
             "JjJVOi " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' jo[TVOi\
    '---------------------------------------------------------------
    If False = Aisa59wGetUniversalSignal(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aISA-M59" + Chr(10) + _
             "jo[TVOi " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' foCX
    '---------------------------------------------------------------
    If False = Aisa59wClose(wLogSlot) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aISA-M59 Closed")
    '---------------------------------------------------------------
    ' Aisa59.Dll 
    '---------------------------------------------------------------
    If False = Aisa59wDllClose() Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub
    End If


End Sub
'===================================================================
' 䎲̏
'-------------------------------------------------------------------
'           wLogSlot    foCXԍ
'               wAxis       䎲
'                           AISA59_AXIS_1 ` AISA59_AXIS_4 w肵܂
'===================================================================
Function Aisa59_InitAxis(ByVal wLogSlot As Integer, ByVal wAxis As Integer) As Integer

    Aisa59_InitAxis = False
    '---------------------------------------------------------------
    ' MODE1 SET
    '
    ' Jn|Cgo              
    ' pXo͕                        QpX
    ' DIR   o͒[q                        CWpX  ANeBu Hi
    ' PULSE o͒[q                        CCWpX ANeBu Hi
    '---------------------------------------------------------------
    If False = Aisa59wMode1Write(wLogSlot, wAxis, &H40) Then Exit Function
    '---------------------------------------------------------------
    ' MODE2 SET
    '
    ' EXTERNAL COUNTER ͎dl             QMS{
    ' DEND ͐MANeBux         Low
    ' DERR ͐MANeBux         Low
    ' -SLM ͐MANeBux         Low
    ' +SLM ͐MANeBux         Low
    ' -ELM ͐MANeBux         Low
    ' +ELM ͐MANeBux         Low
    '---------------------------------------------------------------
    If False = Aisa59wMode2Write(wLogSlot, wAxis, &HFF) Then Exit Function
    '---------------------------------------------------------------
    ' [hݒ
    '
    ' INPOSITION WAIT MODE RESET
    ' ALARM STOP ENABLE MODE SET
    ' INTERRUPT OUT ENABLE MODE RESET
    '---------------------------------------------------------------
    If False = Aisa59wCommandWrite(wLogSlot, wAxis, AISA59_INPOSITION_WAIT_MODE_RESET) Then Exit Function
    If False = Aisa59wCommandWrite(wLogSlot, wAxis, AISA59_ALARM_STOP_ENABLE_MODE_SET) Then Exit Function
    If False = Aisa59wCommandWrite(wLogSlot, wAxis, AISA59_INTERRUPT_OUT_ENABLE_MODE_RESET) Then Exit Function
    '---------------------------------------------------------------
    ' f[^ݒ
    '
    ' RANGE DATA                 50  o͎gݒP  50050=10PPS
    ' START/STOP SPEED DATA     100  Jn~g      100~10PPS=1000PPS
    ' OBJECT SPEED DATA        4000  ړIg          4000~10PPS=40000PPS
    ' RATE-1 DATA              1024  ԐݒP    1024(2.048~10^6)=0.5mSec
    '                                            (4000-100)~0.5mSec = 1.95Sec
    ' RATE-2 DATA                    ftHgl 8191(1FFFh)
    ' RATE-3 DATA                    ftHgl 8191(1FFFh)
    ' RATE CHANGE POINT 1-2          ftHgl 8191(1FFFh)
    ' RATE CHANGE POINT 2-3          ftHgl 8191(1FFFh)
    '
    ' ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
    '---------------------------------------------------------------
    If False = Aisa59wDataHalfWrite(wLogSlot, wAxis, AISA59_RANGE_WRITE, 50) Then Exit Function
    If False = Aisa59wDataHalfWrite(wLogSlot, wAxis, AISA59_START_STOP_SPEED_DATA_WRITE, 100) Then Exit Function
    If False = Aisa59wDataFullWrite(wLogSlot, wAxis, AISA59_OBJECT_SPEED_DATA_WRITE, 4000) Then Exit Function
    If False = Aisa59wDataFullWrite(wLogSlot, wAxis, AISA59_RATE1_DATA_WRITE, 1024) Then Exit Function
    '---------------------------------------------------------------
    ' AhXݒ
    '
    ' INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
    '---------------------------------------------------------------
    If False = Aisa59wDataFullWrite(wLogSlot, wAxis, AISA59_INTERNAL_COUNTER_WRITE, 0) Then Exit Function
    If False = Aisa59wDataFullWrite(wLogSlot, wAxis, AISA59_EXTERNAL_COUNTER_WRITE, 0) Then Exit Function

    Aisa59_InitAxis = True

End Function
'===================================================================
' ʂ\
'===================================================================
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub
'===================================================================
' G[bZ[W\
'===================================================================
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Aisa59wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA59_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-M59 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub


